import { jsx as _jsx } from "react/jsx-runtime";
import AbTestToggle from '@s-ui/abtesting-toggle';
import { useExperimentCore as useExperimentCoreFromPackage } from '@s-ui/abtesting-hooks';
import ExperimentProviderOnly from '../experiment-provider-only';
import experimentPropsMapper from './experiment-props-mapper';

function ExperimentProviderAndCore(props) {
  var deps = props.deps,
      children = props.children;
  var useExperimentCore = deps && deps.useExperimentCore || useExperimentCoreFromPackage;
  var experimentParams = experimentPropsMapper(props);

  var _useExperimentCore = useExperimentCore(experimentParams),
      experimentDataFromCore = _useExperimentCore.experimentData;

  return /*#__PURE__*/_jsx(ExperimentProviderOnly, {
    experimentData: experimentDataFromCore,
    children: /*#__PURE__*/_jsx(AbTestToggle, {
      variation: experimentDataFromCore.variationId,
      children: children
    })
  });
}

export default ExperimentProviderAndCore;