import _extends from "@babel/runtime/helpers/esm/extends";
import { jsx as _jsx } from "react/jsx-runtime";
import PropTypes from 'prop-types';
import { getExperimentContext } from './context';
import ExperimentProviderOnly from './experiment-provider-only';
import ExperimentProviderAndCore from './experiment-provider-and-core';

function AbTestOptimizelyXExperiment(props) {
  var isProviderOnly = !!props.feed;
  var experimentData = isProviderOnly ? props.feed : props; // ACT AS AN EXPERIMENT CONTEXT PROVIDER ONLY
  // - feeds from an external experiment and provides data from it to the context

  if (isProviderOnly) return /*#__PURE__*/_jsx(ExperimentProviderOnly, _extends({}, props, {
    experimentData: experimentData
  })); // ACT AS AN EXPERIMENT CORE RUNNER AND CONTEXT PROVIDER
  // - internally runs the experiment and provides data from it to the context

  return /*#__PURE__*/_jsx(ExperimentProviderAndCore, _extends({}, experimentData));
}

AbTestOptimizelyXExperiment.displayName = 'AbTestOptimizelyXExperiment';

var EmptyVariation = function EmptyVariation(props) {
  return null;
};

EmptyVariation.propTypes = {
  defaultVariation: PropTypes.bool,
  variationId: PropTypes.number.isRequired
};
export default AbTestOptimizelyXExperiment;
export { EmptyVariation, getExperimentContext };